---
title: CredentialsContainer.create()
slug: Web/API/CredentialsContainer/create
tags:
  - API
  - Credential Management API
  - CredentialsContainer
  - Method
  - Reference
  - credential management
---
<p>{{APIRef("Credential Management")}}{{SeeCompatTable}}</p>

<p>The <strong><code>create()</code></strong> method of the {{domxref("CredentialsContainer")}} interface returns a {{jsxref("Promise")}} that resolves with a new {{domxref("Credential")}} instance based on the provided options, or <code>null</code> if no <code>Credential</code> object can be created.</p>

<div class="note">
<p>This method is restricted to top-level contexts. Calls to it within an <code>&lt;iframe&gt;</code> element will resolve without effect.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var promise = CredentialsContainer.create([options])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>options</dt>
 <dd>An object of type {{domxref("CredentialCreationOptions")}} that contains options for the requested new <code>Credentials</code> object. It must include one of the options "password", "federated", or "publicKey". The options are:
 <ul>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">password</span></font>: {{optional_inline}} Either an {{domxref("HTMLFormElement")}}, or a {{domxref("PasswordCredentialData")}} object. TBD
   <ul>
    <li><code>id</code>: (required) {{domxref("USVString")}} Inherited from {{domxref("CredentialData")}}.</li>
    <li><code>name</code>: {{optional_inline}} {{domxref("USVString")}} TBD</li>
    <li><code>iconURL</code>: {{optional_inline}} {{domxref("USVString")}} TBD</li>
    <li><code>password</code>: (required) {{domxref("USVString")}} TBD</li>
   </ul>
  </li>
  <li><font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">federated</span></font>: {{optional_inline}} An {{domxref("FederatedCredentialInit")}} object. Contains requirements for creating/obtaining federated credentials. The available options are:
   <ul>
    <li><code>id</code>: (required) {{domxref("USVString")}} Inherited from {{domxref("CredentialData")}}.</li>
    <li><code>name</code>: {{optional_inline}} {{domxref("USVString")}} TBD</li>
    <li><code>iconURL</code>: {{optional_inline}} {{domxref("USVString")}} TBD</li>
    <li><code>provider</code>: (required) {{domxref("USVString")}} TBD</li>
    <li><code>protocol</code>: {{optional_inline}} {{domxref("USVString")}} TBD</li>
   </ul>
  </li>
  <li><code>publicKey</code>: {{optional_inline}} an {{domxref("PublicKeyCredentialCreationOptions")}} object that describes the options for creating a <a href="/en-US/docs/Web/API/Web_Authentication_API">WebAuthn</a> credential.</li>
 </ul>
 </dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} that resolves with a {{domxref("Credential")}} instance, such as {{domxref("PasswordCredential")}}, {{domxref("FederatedCredential")}}, or {{domxref("PublicKeyCredential")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Credential Management','#dom-credentialscontainer-get','get()')}}</td>
   <td>{{Spec2('Credential Management')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebAuthn')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.CredentialsContainer.create")}}</p>
</div>
